Overview | Package | Class | Deprecated | Index | Help
| Groovy Documentation
| FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | PROPERTY | CONSTR | METHOD | DETAIL: FIELD | PROPERTY | CONSTR | METHOD

## grails.util
[Groovy] Class PluginBuildSettings

    java.lang.Object
      grails.util.PluginBuildSettings

    class PluginBuildSettings

Uses the project BuildSettings object to discover information about the installed plugin such as the jar files they provide, the plugin descriptors and so on.

Authors:
  Graeme Rocher

Since:
  1.2

Field Summary
`static java.lang.Object` | `EXCLUDED_RESOURCES` Resources to be excluded from the final packaged plugin.

Property Summary
`BuildSettings` | `buildSettings`
`GrailsPluginManager` | `pluginManager`
`groovy.lang.Closure` | `resourceResolver` A default resolver used if none is specified to the resource resolving methods in this class.

Constructor Summary
`PluginBuildSettings(BuildSettings buildSettings)`
`PluginBuildSettings(BuildSettings buildSettings, GrailsPluginManager pluginManager)`

Method Summary
`void` | `clearCache()` Clears any cached entries.
`Resource[]` | `getArtefactResources()` Obtains a reference to all artefact resources (all Groovy files contained within the grails-app directory of plugins or applications).
`Resource[]` | `getArtefactResourcesForOne(java.lang.String projectDir)` Returns an array of all artefacts in the given application or plugin directory as Spring resources.
`Resource[]` | `getAvailableScripts()` Obtains an array of all Gant scripts that are availabe for execution in a Grails application.
`Resource` | `getBasePluginDescriptor()` Obtains the 'base' plugin descriptor, which is the plugin descriptor of the current plugin project.
`Resource` | `getDescriptorForPlugin(Resource pluginDir)` Returns the descriptor location for the given plugin directory.
`java.lang.String` | `getGlobalPluginsPath()` Obtains the path to the global plugins directory.
`java.util.List` | `getImplicitPluginDirectories()` Returns a list of all plugin directories in both the given path and the global "plugins" directory together.
`Resource[]` | `getInlinePluginDirectories()` Returns an array of the inplace plugin locations.
`groovy.util.slurpersupport.GPathResult` | `getMetadataForPlugin(java.lang.String pluginName)` Returns XML about the plugin.
`groovy.util.slurpersupport.GPathResult` | `getMetadataForPlugin(Resource pluginDir)` Returns XML metadata for the plugin.
`java.util.List` | `getPluginBaseDirectories()` Gets a list of all the known plugin base directories (directories where plugins are installed to).
`Resource` | `getPluginDescriptor(Resource pluginDir)` Returns the plugin descriptor for the Given plugin directory.
`Resource[]` | `getPluginDescriptors()` /*.groovy") }
`Resource` | `getPluginDirForName(java.lang.String pluginName)` Obtains a plugin directory for the given name.
`Resource[]` | `getPluginDirectories()` Obtains a list of plugin directories for the application
`Resource[]` | `getPluginI18nDirectories()` Obtains an array of all plugin i18n directories.
`GrailsPluginInfo` | `getPluginInfo(java.lang.String pluginBaseDir)` Obtains a PluginInfo for the installed plugin directory.
`GrailsPluginInfo` | `getPluginInfoForName(java.lang.String pluginName)` Obtains a PluginInfo for the installed plugin directory.
`GrailsPluginInfo` | `getPluginInfoForSource(java.lang.String sourceFile)` Gets a PluginInfo for a particular source file if its contained within that plugin
`GrailsPluginInfo[]` | `getPluginInfos(java.lang.String pluginDirPath = this.pluginDirPath)` Returns an array of PluginInfo objects
`Resource[]` | `getPluginJarFiles()` Obtains an array of all plugin provided JAR files
`Resource[]` | `getPluginLibDirectories()` Obtains an array of all plugin lib directories.
`Resource[]` | `getPluginResourceBundles()` Obtains an array of all plugin provided resource bundles.
`Resource[]` | `getPluginScripts()` .groovy").each { if (!
`Resource[]` | `getPluginSourceFiles()` /*.properties") } }
`Resource[]` | `getPluginSourceFiles(java.io.File pluginDir)`
`Resource[]` | `getPluginXmlMetadata()` Obtains a Resource array of the Plugin metadata XML files used to describe the plugins provided resources
`GrailsPluginInfo[]` | `getSupportedPluginInfos()` Returns only the PluginInfo objects that support the current Environment and BuildScope.
`Resource[]` | `getUnmanagedPluginJarFiles()` Obtains an array of all plugin provided JAR files for plugins that don't define a dependencies.groovy.
`boolean` | `isGlobalPluginLocation(Resource pluginDir)` Returns true if the specified plugin directory is a global plugin.
`boolean` | `isInlinePluginLocation(Resource pluginLocation)` Returns true if the specified plugin location is an inline location.

Methods inherited from class java.lang.Object
java.lang.Object#wait(), java.lang.Object#wait(long), java.lang.Object#wait(long, int), java.lang.Object#equals(java.lang.Object), java.lang.Object#toString(), java.lang.Object#hashCode(), java.lang.Object#getClass(), java.lang.Object#notify(), java.lang.Object#notifyAll()

Field Detail

### EXCLUDED_RESOURCES

    public static final java.lang.Object EXCLUDED_RESOURCES

  Resources to be excluded from the final packaged plugin. Defined as Ant paths.

Property Detail

### buildSettings

    BuildSettings buildSettings

### pluginManager

    GrailsPluginManager pluginManager

### resourceResolver

    groovy.lang.Closure resourceResolver

  A default resolver used if none is specified to the resource resolving methods in this class.

Constructor Detail

### PluginBuildSettings

    PluginBuildSettings(BuildSettings buildSettings)

### PluginBuildSettings

    PluginBuildSettings(BuildSettings buildSettings, GrailsPluginManager pluginManager)

Method Detail

### clearCache

    void clearCache()

  Clears any cached entries.

### getArtefactResources

    Resource[] getArtefactResources()

  Obtains a reference to all artefact resources (all Groovy files contained within the grails-app directory of plugins or applications).

### getArtefactResourcesForOne

    Resource[] getArtefactResourcesForOne(java.lang.String projectDir)

  Returns an array of all artefacts in the given application or plugin directory as Spring resources.

### getAvailableScripts

    Resource[] getAvailableScripts()

  Obtains an array of all Gant scripts that are availabe for execution in a Grails application.

### getBasePluginDescriptor

    Resource getBasePluginDescriptor()

  Obtains the 'base' plugin descriptor, which is the plugin descriptor of the current plugin project.

### getDescriptorForPlugin

    Resource getDescriptorForPlugin(Resource pluginDir)

  Returns the descriptor location for the given plugin directory. The descriptor is the Groovy file that ends with *GrailsPlugin.groovy

### getGlobalPluginsPath

    java.lang.String getGlobalPluginsPath()

  Obtains the path to the global plugins directory.

### getImplicitPluginDirectories

    java.util.List getImplicitPluginDirectories()

  Returns a list of all plugin directories in both the given path and the global "plugins" directory together.

### getInlinePluginDirectories

    Resource[] getInlinePluginDirectories()

  Returns an array of the inplace plugin locations.

### getMetadataForPlugin

    groovy.util.slurpersupport.GPathResult getMetadataForPlugin(java.lang.String pluginName)

  Returns XML about the plugin.

### getMetadataForPlugin

    groovy.util.slurpersupport.GPathResult getMetadataForPlugin(Resource pluginDir)

  Returns XML metadata for the plugin.

### getPluginBaseDirectories

    java.util.List getPluginBaseDirectories()

  Gets a list of all the known plugin base directories (directories where plugins are installed to).

### getPluginDescriptor

    Resource getPluginDescriptor(Resource pluginDir)

  Returns the plugin descriptor for the Given plugin directory.
  Parameters:
    `pluginDir` - The plugin directory
  Returns:
    The plugin descriptor

### getPluginDescriptors

    Resource[] getPluginDescriptors()

  /*.groovy") } /** Obtains an array of all plugin descriptors (the root classes that end with *GrailsPlugin.groovy).

### getPluginDirForName

    Resource getPluginDirForName(java.lang.String pluginName)

  Obtains a plugin directory for the given name.

### getPluginDirectories

    Resource[] getPluginDirectories()

  Obtains a list of plugin directories for the application

### getPluginI18nDirectories

    Resource[] getPluginI18nDirectories()

  Obtains an array of all plugin i18n directories.

### getPluginInfo

    GrailsPluginInfo getPluginInfo(java.lang.String pluginBaseDir)

  Obtains a PluginInfo for the installed plugin directory.

### getPluginInfoForName

    GrailsPluginInfo getPluginInfoForName(java.lang.String pluginName)

  Obtains a PluginInfo for the installed plugin directory.

### getPluginInfoForSource

    GrailsPluginInfo getPluginInfoForSource(java.lang.String sourceFile)

  Gets a PluginInfo for a particular source file if its contained within that plugin

### getPluginInfos

    GrailsPluginInfo[] getPluginInfos(java.lang.String pluginDirPath = this.pluginDirPath)

  Returns an array of PluginInfo objects

### getPluginJarFiles

    Resource[] getPluginJarFiles()

  Obtains an array of all plugin provided JAR files

### getPluginLibDirectories

    Resource[] getPluginLibDirectories()

  Obtains an array of all plugin lib directories.

### getPluginResourceBundles

    Resource[] getPluginResourceBundles()

  Obtains an array of all plugin provided resource bundles.

### getPluginScripts

    Resource[] getPluginScripts()

  .groovy").each { if (!it.file.name.startsWith('_')) scripts << it } resourceResolver("file:${basedir}/scripts/*.groovy").each { if (!it.file.name.startsWith('_')) scripts << it } pluginScripts.each { if (!it.file.name.startsWith('_')) scripts << it } resourceResolver("file:${userHome}/.grails/scripts/*.groovy").each { if (!it.file.name.startsWith('_')) scripts << it } availableScripts = scripts as Resource[] cache.availableScripts = availableScripts } return availableScripts } /** Obtains an array of plugin provided Gant scripts available to a Grails application.

### getPluginSourceFiles

    Resource[] getPluginSourceFiles()

  /*.properties") } } /** Obtains an array of all plugin provided source files (Java and Groovy).

### getPluginSourceFiles

    Resource[] getPluginSourceFiles(java.io.File pluginDir)

### getPluginXmlMetadata

    Resource[] getPluginXmlMetadata()

  Obtains a Resource array of the Plugin metadata XML files used to describe the plugins provided resources

### getSupportedPluginInfos

    GrailsPluginInfo[] getSupportedPluginInfos()

  Returns only the PluginInfo objects that support the current Environment and BuildScope.
  See Also:
    Environment
    BuildScope

### getUnmanagedPluginJarFiles

    Resource[] getUnmanagedPluginJarFiles()

  Obtains an array of all plugin provided JAR files for plugins that don't define a dependencies.groovy.

### isGlobalPluginLocation

    boolean isGlobalPluginLocation(Resource pluginDir)

  Returns true if the specified plugin directory is a global plugin.

### isInlinePluginLocation

    boolean isInlinePluginLocation(Resource pluginLocation)

  Returns true if the specified plugin location is an inline location.

Groovy Documentation